﻿#SingleInstance force
#Persistent
#NoEnv
FileEncoding, UTF-8-RAW
global query:= A_Temp . "\baidu.sql"
global sqlite3 := A_WorkingDir "\sqlite3.exe"
dbFile:=
Folder:=
IfNotExist, %sqlite3%
{
	MsgBox, sqlite3.exe 파일이 없습니다.
	return
}
gosub, Gui
return

Gui:
	Gui, add, text, w250, DB파일을 놓으세요 (BaiduYunGuanjia.db)
	Gui, add, edit, xs w250 vcmd_name1 section, 파일 이름
	Gui, add, edit, xs w250 vcmd_path1, DB파일 경로	
	Gui, add, button, xs w100 gSelFolder,폴더 선택
	Gui, add, text, xp+120 w130 yp+6 , 생성할 폴더 설정
	Gui, add, edit, xs w250 vcmd_path2, 생성할 파일 경로	
	Gui, add, DDL, xs+190 w60 vPatt gSelDDL AltSubmit,CSV||`List|`TAB|칼럼
	Gui, add, text, xp-190 w190 yp+5, 생성할 파일 종류를 선택하세요
	Gui, add, edit, xs w250 r5 vmatch,
	Gui, add, button, xs w100 vRun,실행
	Gui, add, button, xp+150  w100 vReset,초기화
	Gui, show
	gosub, selDDL
return

SelDDL:
GuiControlGet, ddlVar,,Patt
if ( ddlVar = 1 )
	mode:="csv"
if ( ddlVar = 2 )
	mode:="list"
if ( ddlVar = 3 )
	mode:="tabs"
if ( ddlVar = 4 )
	mode:="column"

sql := ".header on`n"
sql .= ".mode " mode
sql .= "`nselect md5,file_size,server_filename,server_path from cache_file where md5>0 order by file_size asc;"
GuiControl,,match,%sql%
return

SelFolder:
	FileSelectFolder, Folder
	Folder := RegExReplace(Folder, "\\$")
	GuiControl,,cmd_path2,%Folder%
	gosub, SelDDL
return

parse_cmd:
	Loop , parse, parameter, `r`n
	{
		if ( drop = "cmd_path1" or drop = "cmd_name1" ){
			dbFile = %A_LoopField%
		}else if ( drop = "cmd_path2" or drop = "cmd_name2" ){
			Folder := RegExReplace(A_LoopField, "\\$")		
		}else{
			ToolTip, 정확한 위치에 놓으세요.
			Sleep,1000
			ToolTip
		}
		dropfile_path:=A_LoopField
		StringRight, num,drop,1
		SplitPath ,dropfile_path, ,,,dropfile_name
		GuiControl  ,,cmd_name%num%, %dropfile_name%
		GuiControl  ,,cmd_path%num%, %dropfile_path%
	 Break
	}
	gosub, SelDDL
return

Action:
IfExist, %query%
	FileDelete, %query%
FileAppend, %sql%, %query%
if ( mode = "csv" )
	OutputFile := Folder "\" A_Now "." mode
else
	OutputFile := Folder "\" A_Now ".txt"
cmd := sqlite3 " """ dbFile """  < """ query """ > """ OutputFile """"
RunWait, %ComSpec% /c %cmd%, , Hide UseErrorLevel
if (Errorlevel) {
	FileRead, tempQuery, %query%
	newQuery := RegExReplace(tempQuery,"server_path","parent_path")
	FileDelete, %query%
	FileAppend, %newQuery%, %query%
	RunWait, %ComSpec% /c %cmd%, , Hide UseErrorLevel
	if ( ErrorLevel ){
		FileDelete, %OutputFile%
		MsgBox, 추출 실패!
	}else{
		gosub, success
	}
}else{
	gosub, success
}
return

success:
	FileRead, tempVar, %OutputFile%
	FileDelete, %OutputFile%
	FileAppend, %tempVar%, %OutputFile%, UTF-8
	tempVar:=
	MsgBox, 추출 성공!
return

GuiDropFiles:
	parameter := A_GuiEvent
	drop:=A_GuiControl	
	gosub parse_cmd
return

Button실행:
	gui,submit,nohide
	if ( dbFile = "" )
	{
		MsgBox, DB파일을 지정하세요
		return
	}
	if ( Folder = "" )
	{
		MsgBox,4,폴더 지정,폴더가 설정되지 않았습니다.`n스크립트가 실행된 폴더로 기본 지정됩니다`n계속 하시겠습니까?
		IfMsgBox, Yes
		{
			Folder = %A_WorkingDir%
			gosub, SelDDL
		}else{
			return
		}
	}
	gosub, Action
return

Button초기화:
	Reload
return

Exit:
GuiClose:
IfExist, %query%
	FileDelete, %query%
ExitApp